searchData={"items":[{"type":"module","title":"Ext.Date","doc":"`Ext.Date` provides helper functions related to `Date`.","ref":"Ext.Date.html"},{"type":"function","title":"Ext.Date.today!/2","doc":"Returns the date today in the specified time zone. May require a time zone database. See [here](https://hexdocs.pm/elixir/DateTime.html#module-time-zone-database) for details.","ref":"Ext.Date.html#today!/2"},{"type":"module","title":"Ext.Enum","doc":"`Ext.Enum` provides helper functions related to `Enum`.","ref":"Ext.Enum.html"},{"type":"function","title":"Ext.Enum.repeat/2","doc":"Returns a list by invoking the mapper function the given number of times.","ref":"Ext.Enum.html#repeat/2"},{"type":"function","title":"Examples - Ext.Enum.repeat/2","doc":"iex> Ext.Enum.repeat(3, &(&1 + 5))\n    [5, 6, 7]","ref":"Ext.Enum.html#repeat/2-examples"},{"type":"protocol","title":"Ext.Functor","doc":"`Ext.Functor` is a protocol for data that can be mapped over. Unlike\n`Enum.map`, which always returns a list, `Ext.Functor.map` returns the same\ndata structure as the input. For example, mapping over a list returns a\nlist while mapping over a map returns a map.","ref":"Ext.Functor.html"},{"type":"function","title":"Ext.Functor.map/2","doc":"","ref":"Ext.Functor.html#map/2"},{"type":"type","title":"Ext.Functor.t/0","doc":"All the types that implement this protocol.","ref":"Ext.Functor.html#t:t/0"},{"type":"module","title":"Ext.LenientMap","doc":"`Ext.LenientMap` provides helper functions related to `Map` by treating\nstring and atom keys as equivalent.","ref":"Ext.LenientMap.html"},{"type":"function","title":"Ext.LenientMap.delete/2","doc":"Delete a specific key from the `map`.\n\nIf the `map` has both the atom and string keys, both of them will be deleted.","ref":"Ext.LenientMap.html#delete/2"},{"type":"function","title":"Examples - Ext.LenientMap.delete/2","doc":"iex> Ext.LenientMap.delete(%{a: 1, b: 2}, :a)\n    %{b: 2}\n\n    iex> Ext.LenientMap.delete(%{\"a\" => 1, \"b\" => 2}, :a)\n    %{\"b\" => 2}\n\n    iex> Ext.LenientMap.delete(%{\"a\" => 1, :a => 2, \"b\" => 3}, :a)\n    %{\"b\" => 3}\n\n    iex> Ext.LenientMap.delete(%{a: 1, b: 2}, :c)\n    %{a: 1, b: 2}","ref":"Ext.LenientMap.html#delete/2-examples"},{"type":"function","title":"Ext.LenientMap.get/3","doc":"Returns the value for a specific key from the `map`.\n\nIf a value can be found using both the atom and string keys, the value given\nby the atom key is returned.","ref":"Ext.LenientMap.html#get/3"},{"type":"function","title":"Examples - Ext.LenientMap.get/3","doc":"iex> Ext.LenientMap.get(%{a: 1, b: 2}, :a)\n    1\n\n    iex> Ext.LenientMap.get(%{\"a\" => 1, \"b\" => 2}, :a)\n    1\n\n    iex> Ext.LenientMap.get(%{\"a\" => 1, :a => 2, \"b\" => 3}, :a)\n    2\n\n    iex> Ext.LenientMap.get(%{a: 1, b: 2}, :c)\n    nil\n\n    iex> Ext.LenientMap.get(%{a: 1, b: 2}, :c, :not_found)\n    :not_found","ref":"Ext.LenientMap.html#get/3-examples"},{"type":"function","title":"Ext.LenientMap.get_and_delete/3","doc":"Returns the value for a specific key and delete it from the `map`.\n\nIf a value can be found using both the atom and string keys, the value given\nby the atom key is returned, but both entries are dropped from the map.","ref":"Ext.LenientMap.html#get_and_delete/3"},{"type":"function","title":"Examples - Ext.LenientMap.get_and_delete/3","doc":"iex> Ext.LenientMap.get_and_delete(%{a: 1, b: 2}, :a)\n    {1, %{b: 2}}\n\n    iex> Ext.LenientMap.get_and_delete(%{\"a\" => 1, \"b\" => 2}, :a)\n    {1, %{\"b\" => 2}}\n\n    iex> Ext.LenientMap.get_and_delete(%{\"a\" => 1, :a => 2, \"b\" => 3}, :a)\n    {2, %{\"b\" => 3}}\n\n    iex> Ext.LenientMap.get_and_delete(%{a: 1, b: 2}, :c)\n    {nil, %{a: 1, b: 2}}\n\n    iex> Ext.LenientMap.get_and_delete(%{a: 1, b: 2}, :c, :not_found)\n    {:not_found, %{a: 1, b: 2}}","ref":"Ext.LenientMap.html#get_and_delete/3-examples"},{"type":"function","title":"Ext.LenientMap.has_key?/2","doc":"Returns true if the `map` as the specified key as an atom or a string.","ref":"Ext.LenientMap.html#has_key?/2"},{"type":"function","title":"Examples - Ext.LenientMap.has_key?/2","doc":"iex> Ext.LenientMap.has_key?(%{a: 1, b: 2}, :a)\n    true\n\n    iex> Ext.LenientMap.has_key?(%{\"a\" => 1, \"b\" => 2}, :a)\n    true\n\n    iex> Ext.LenientMap.has_key?(%{\"a\" => 1, :a => 2, \"b\" => 3}, :a)\n    true\n\n    iex> Ext.LenientMap.has_key?(%{a: 1, b: 2}, :c)\n    false","ref":"Ext.LenientMap.html#has_key?/2-examples"},{"type":"function","title":"Ext.LenientMap.put/3","doc":"Puts the given `value` in `map`. An atom key is used if `map` has primarily\natom keys. Otherwise, a string key is used.","ref":"Ext.LenientMap.html#put/3"},{"type":"function","title":"Examples - Ext.LenientMap.put/3","doc":"iex> Ext.LenientMap.put(%{a: 1, b: 2}, :c, 3)\n    %{a: 1, b: 2, c: 3}\n\n    iex> Ext.LenientMap.put(%{\"a\" => 1, \"b\" => 2}, :c, 3)\n    %{\"a\" => 1, \"b\" => 2, \"c\" => 3}","ref":"Ext.LenientMap.html#put/3-examples"},{"type":"function","title":"Ext.LenientMap.update!/3","doc":"Updates the value at the specified key with the given function.\n\nIf a value can be found using both the atom and string keys, the value given\nby the atom key is passed to the updater while the string key is deleted from\nthe map.\n\nIf the key is not present in `map`, a `KeyError` exception is raised.","ref":"Ext.LenientMap.html#update!/3"},{"type":"function","title":"Examples - Ext.LenientMap.update!/3","doc":"iex> Ext.LenientMap.update!(%{a: 1, b: 2}, :a, &(&1 * 10))\n    %{a: 10, b: 2}\n\n    iex> Ext.LenientMap.update!(%{\"a\" => 1, \"b\" => 2}, :a, &(&1 * 10))\n    %{\"a\" => 10, \"b\" => 2}\n\n    iex> Ext.LenientMap.update!(%{\"a\" => 1, :a => 2, \"b\" => 3}, :a, &(&1 * 10))\n    %{:a => 20, \"b\" => 3}\n\n    iex> Ext.LenientMap.update!(%{}, :c, &(&1 * 10))\n    ** (KeyError) key :c not found in: %{}","ref":"Ext.LenientMap.html#update!/3-examples"},{"type":"module","title":"Ext.Nil","doc":"`Ext.Nil` provides helper functions for values that can potentially be `nil`.","ref":"Ext.Nil.html"},{"type":"function","title":"Ext.Nil.map/2","doc":"Transforms the given value using the `mapper` function if the value is not\n`nil`. Returns `nil` otherwise.","ref":"Ext.Nil.html#map/2"},{"type":"function","title":"Examples - Ext.Nil.map/2","doc":"iex> Ext.Nil.map(3, &(&1 + 5))\n    8\n\n    iex> Ext.Nil.map(nil, &(&1 + 5))\n    nil","ref":"Ext.Nil.html#map/2-examples"},{"type":"module","title":"Ext.Random","doc":"`Ext.Random` provides helper functions to produce random values. Note that\nthese functions are **not** suitable for cryptographic use.","ref":"Ext.Random.html"},{"type":"function","title":"Ext.Random.alphanumeric/1","doc":"Returns a random alphanumeric (a-z, A-Z, 0-9) string of the specified length.\nThe characters are chosen with replacement.","ref":"Ext.Random.html#alphanumeric/1"},{"type":"function","title":"Ext.Random.sample/1","doc":"Returns a random codepoint from the input string.","ref":"Ext.Random.html#sample/1"},{"type":"module","title":"Ext.String","doc":"`Ext.String` provides helper functions related to strings.","ref":"Ext.String.html"},{"type":"function","title":"Ext.String.is_empty?/1","doc":"Returns true if and only if the input is `nil` or a zero-length string.","ref":"Ext.String.html#is_empty?/1"},{"type":"function","title":"Examples - Ext.String.is_empty?/1","doc":"iex> Ext.String.is_empty?(nil)\n    true\n\n    iex> Ext.String.is_empty?(\"\")\n    true\n\n    iex> Ext.String.is_empty?(\"  \")\n    false\n\n    iex> Ext.String.is_empty?(\"hello\")\n    false","ref":"Ext.String.html#is_empty?/1-examples"},{"type":"function","title":"Ext.String.is_not_empty?/1","doc":"Returns false if and only if the input is a string with non-zero length.","ref":"Ext.String.html#is_not_empty?/1"},{"type":"function","title":"Examples - Ext.String.is_not_empty?/1","doc":"iex> Ext.String.is_not_empty?(nil)\n    false\n\n    iex> Ext.String.is_not_empty?(\"\")\n    false\n\n    iex> Ext.String.is_not_empty?(\"  \")\n    true\n\n    iex> Ext.String.is_not_empty?(\"hello\")\n    true","ref":"Ext.String.html#is_not_empty?/1-examples"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}